diff --git a/gcc/ada/backend_utils.adb b/gcc/ada/backend_utils.adb
index 6f4b5878acb..3591cd19bbf 100644
--- a/gcc/ada/backend_utils.adb
+++ b/gcc/ada/backend_utils.adb
@@ -38,7 +38,6 @@ package body Backend_Utils is
       First : constant Positive := Switch_Chars'First + 1;
       Last  : constant Natural  := Switch_Last (Switch_Chars);
    begin
-
       --  Recognize -gxxx switches
 
       if Switch_Chars (First) = 'g' then
diff --git a/gcc/ada/errout.adb b/gcc/ada/errout.adb
index 1d82386099c..c6534fe2a76 100644
--- a/gcc/ada/errout.adb
+++ b/gcc/ada/errout.adb
@@ -2498,7 +2498,6 @@ package body Errout is
    --  Start of processing for Output_JSON_Message
 
    begin
-
       --  Print message kind
 
       Write_Str ("{""kind"":");
diff --git a/gcc/ada/erroutc.adb b/gcc/ada/erroutc.adb
index aa9aac4774f..7a823cefe56 100644
--- a/gcc/ada/erroutc.adb
+++ b/gcc/ada/erroutc.adb
@@ -1162,7 +1162,6 @@ package body Erroutc is
 
    procedure Set_Msg_Char (C : Character) is
    begin
-
       --  The check for message buffer overflow is needed to deal with cases
       --  where insertions get too long (in particular a child unit name can
       --  be very long).
diff --git a/gcc/ada/exp_aggr.adb b/gcc/ada/exp_aggr.adb
index 2031d042fa5..59ed75e8d69 100644
--- a/gcc/ada/exp_aggr.adb
+++ b/gcc/ada/exp_aggr.adb
@@ -9636,7 +9636,6 @@ package body Exp_Aggr is
       --  One-dimensional subaggregate
 
    begin
-
       --  For now, only deal with cases where an integral number of elements
       --  fit in a single byte. This includes the most common boolean case.
 
diff --git a/gcc/ada/exp_pakd.adb b/gcc/ada/exp_pakd.adb
index 00bf60ae406..3674d31bbab 100644
--- a/gcc/ada/exp_pakd.adb
+++ b/gcc/ada/exp_pakd.adb
@@ -1511,7 +1511,6 @@ package body Exp_Pakd is
       Offset : Node_Id;
 
    begin
-
       if CodePeer_Mode then
          return;
       end if;
@@ -1555,7 +1554,6 @@ package body Exp_Pakd is
       Offset : Node_Id;
 
    begin
-
       if CodePeer_Mode then
          return;
       end if;
@@ -1595,7 +1593,6 @@ package body Exp_Pakd is
       PAT  : Entity_Id;
 
    begin
-
       if CodePeer_Mode then
          return;
       end if;
@@ -1763,7 +1760,6 @@ package body Exp_Pakd is
       Arg   : Node_Id;
 
    begin
-
       if CodePeer_Mode then
          return;
       end if;
@@ -1931,7 +1927,6 @@ package body Exp_Pakd is
       PAT  : Entity_Id;
 
    begin
-
       if CodePeer_Mode then
          return;
       end if;
@@ -2033,7 +2028,6 @@ package body Exp_Pakd is
       Size : Unat;
 
    begin
-
       if CodePeer_Mode then
          return;
       end if;
diff --git a/gcc/ada/exp_prag.adb b/gcc/ada/exp_prag.adb
index a9379025a6b..2c054d1b967 100644
--- a/gcc/ada/exp_prag.adb
+++ b/gcc/ada/exp_prag.adb
@@ -955,7 +955,6 @@ package body Exp_Prag is
          Third_Component  : Entity_Id := Next_Entity (Second_Component);
 
       begin
-
          --  Sem_prag.adb ensured that Init_Val is either a Dim3, an aggregate
          --  of three Any_Integers or Any_Integer.
 
diff --git a/gcc/ada/exp_strm.adb b/gcc/ada/exp_strm.adb
index 43deead525b..75b9d3c845b 100644
--- a/gcc/ada/exp_strm.adb
+++ b/gcc/ada/exp_strm.adb
@@ -455,7 +455,6 @@ package body Exp_Strm is
       Lib_RE  : RE_Id;
 
    begin
-
       --  Check first for Boolean and Character. These are enumeration types,
       --  but we treat them specially, since they may require special handling
       --  in the transfer protocol. However, this special handling only applies
diff --git a/gcc/ada/freeze.adb b/gcc/ada/freeze.adb
index 9c533722985..cf7a22efcae 100644
--- a/gcc/ada/freeze.adb
+++ b/gcc/ada/freeze.adb
@@ -3168,7 +3168,6 @@ package body Freeze is
               Find_Aspect (Typ, Aspect_No_Parts);
             Curr_Aspect_Spec : Entity_Id;
          begin
-
             --  Examine Typ's associated node, when present, since aspect
             --  specifications do not get transferred when nodes get rewritten.
 
@@ -3235,7 +3234,6 @@ package body Freeze is
             Aspect_Spec : constant Entity_Id :=
               Find_Aspect_No_Parts (Typ);
          begin
-
             --  Return the value of the aspect when present
 
             if Present (Aspect_Spec) then
diff --git a/gcc/ada/gen_il-gen.adb b/gcc/ada/gen_il-gen.adb
index b4e10b91d3b..7e58a2c60f2 100644
--- a/gcc/ada/gen_il-gen.adb
+++ b/gcc/ada/gen_il-gen.adb
@@ -1022,7 +1022,6 @@ package body Gen_IL.Gen is
       --  Start of processing for Compute_Field_Offsets
 
       begin
-
          --  Compute the number of types that have each field, weighted by the
          --  frequency of such nodes.
 
diff --git a/gcc/ada/gnat1drv.adb b/gcc/ada/gnat1drv.adb
index 6b6fbf3a174..b532aefcaaa 100644
--- a/gcc/ada/gnat1drv.adb
+++ b/gcc/ada/gnat1drv.adb
@@ -145,7 +145,6 @@ procedure Gnat1drv is
    --  Start of processing for Adjust_Global_Switches
 
    begin
-
       --  -gnatd_U disables prepending error messages with "error:"
 
       if Debug_Flag_Underscore_UU then
diff --git a/gcc/ada/gnat_cuda.adb b/gcc/ada/gnat_cuda.adb
index b531c15d380..f601dd3ceb0 100644
--- a/gcc/ada/gnat_cuda.adb
+++ b/gcc/ada/gnat_cuda.adb
@@ -191,7 +191,6 @@ package body GNAT_CUDA is
 
    procedure Expand_CUDA_Package (N : Node_Id) is
    begin
-
       --  If not compiling for the host, do not do anything.
 
       if not Debug_Flag_Underscore_C then
diff --git a/gcc/ada/gnatchop.adb b/gcc/ada/gnatchop.adb
index 6bb91b17615..3fbb751874e 100644
--- a/gcc/ada/gnatchop.adb
+++ b/gcc/ada/gnatchop.adb
@@ -984,7 +984,6 @@ procedure Gnatchop is
       Read_Ptr    : File_Offset := 1;
 
    begin
-
       loop
          This_Read := Read (FD,
            A => Buffer (Read_Ptr)'Address,
diff --git a/gcc/ada/gnatls.adb b/gcc/ada/gnatls.adb
index c52c1aea9c3..1e8dc858e29 100644
--- a/gcc/ada/gnatls.adb
+++ b/gcc/ada/gnatls.adb
@@ -1573,7 +1573,6 @@ procedure Gnatls is
          Last  : Natural;
 
       begin
-
          if Is_Absolute_Path (Path) then
             if Is_Directory (Path) then
                return new String'(Path);
diff --git a/gcc/ada/make.adb b/gcc/ada/make.adb
index cef24341135..19f20945986 100644
--- a/gcc/ada/make.adb
+++ b/gcc/ada/make.adb
@@ -3022,7 +3022,6 @@ package body Make is
       --  when gnatbind is invoked with -shared.
 
    begin
-
       --  Check now for switch -shared
 
       for J in Binder_Switches.First .. Last_Arg loop
diff --git a/gcc/ada/par-ch11.adb b/gcc/ada/par-ch11.adb
index d4eefe817df..8b51fc7e5b3 100644
--- a/gcc/ada/par-ch11.adb
+++ b/gcc/ada/par-ch11.adb
@@ -163,7 +163,6 @@ package body Ch11 is
 
    function P_Exception_Choice return Node_Id is
    begin
-
       if Token = Tok_Others then
          Scan; -- past OTHERS
          return New_Node (N_Others_Choice, Prev_Token_Ptr);
diff --git a/gcc/ada/par-ch5.adb b/gcc/ada/par-ch5.adb
index 68c3025e3a0..6de9ef0089e 100644
--- a/gcc/ada/par-ch5.adb
+++ b/gcc/ada/par-ch5.adb
@@ -1745,7 +1745,6 @@ package body Ch5 is
       Scan_State : Saved_Scan_State;
 
    begin
-
       Save_Scan_State (Scan_State);
       ID_Node := P_Defining_Identifier (C_In);
 
diff --git a/gcc/ada/par-ch6.adb b/gcc/ada/par-ch6.adb
index 830e6bec83e..7fe43373535 100644
--- a/gcc/ada/par-ch6.adb
+++ b/gcc/ada/par-ch6.adb
@@ -1911,7 +1911,6 @@ package body Ch6 is
          Is_Extended : Boolean := False;
 
       begin
-
          if Token = Tok_Identifier then
             Save_Scan_State (Scan_State); -- at identifier
             Scan; -- past identifier
diff --git a/gcc/ada/sem_attr.adb b/gcc/ada/sem_attr.adb
index d742e1075c0..5720e5e9357 100644
--- a/gcc/ada/sem_attr.adb
+++ b/gcc/ada/sem_attr.adb
@@ -2092,7 +2092,6 @@ package body Sem_Attr is
 
       procedure Check_Dereference is
       begin
-
          --  Case of a subtype mark
 
          if Is_Entity_Name (P) and then Is_Type (Entity (P)) then
diff --git a/gcc/ada/sem_ch12.adb b/gcc/ada/sem_ch12.adb
index 8714efe1461..6b98343aeeb 100644
--- a/gcc/ada/sem_ch12.adb
+++ b/gcc/ada/sem_ch12.adb
@@ -6296,7 +6296,6 @@ package body Sem_Ch12 is
       New_F     : Entity_Id;
 
    begin
-
       Subp := Make_Defining_Identifier (Loc, Chars (Formal_Subp));
       Mutate_Ekind (Subp, Ekind (Formal_Subp));
       Set_Is_Generic_Actual_Subprogram (Subp);
diff --git a/gcc/ada/sem_ch3.adb b/gcc/ada/sem_ch3.adb
index 8787a904e9f..ce3fe18080d 100644
--- a/gcc/ada/sem_ch3.adb
+++ b/gcc/ada/sem_ch3.adb
@@ -10952,7 +10952,6 @@ package body Sem_Ch3 is
    is
       IR : constant Node_Id := Make_Itype_Reference (Sloc (Nod));
    begin
-
       --  Itype references are only created for use by the back-end
 
       if Inside_A_Generic then
diff --git a/gcc/ada/sem_prag.adb b/gcc/ada/sem_prag.adb
index 784c9a49ae3..52d63cf4492 100644
--- a/gcc/ada/sem_prag.adb
+++ b/gcc/ada/sem_prag.adb
@@ -33950,7 +33950,6 @@ package body Sem_Prag is
    --  Start of processing for Validate_Compile_Time_Warning_Errors
 
    begin
-
       --  These error/warning messages were deferred because they could not be
       --  evaluated in the front-end and they needed additional information
       --  from the back-end. There is no reason to run these checks again if
diff --git a/gcc/ada/sem_res.adb b/gcc/ada/sem_res.adb
index 19e52260661..8a18430ff58 100644
--- a/gcc/ada/sem_res.adb
+++ b/gcc/ada/sem_res.adb
@@ -7687,7 +7687,6 @@ package body Sem_Res is
    --  Start of processing for Resolve_Declare_Expression
 
    begin
-
       Decl := First (Actions (N));
 
       while Present (Decl) loop
diff --git a/gcc/ada/sem_util.adb b/gcc/ada/sem_util.adb
index 19941ae3060..032684f3ddb 100644
--- a/gcc/ada/sem_util.adb
+++ b/gcc/ada/sem_util.adb
@@ -1784,7 +1784,6 @@ package body Sem_Util is
 
    function Build_Default_Subtype_OK (T : Entity_Id) return Boolean is
    begin
-
       if Is_Constrained (T) then
 
          --  We won't build a new subtype if T is constrained
diff --git a/gcc/ada/sprint.adb b/gcc/ada/sprint.adb
index 3f73006ad6e..ea16591608b 100644
--- a/gcc/ada/sprint.adb
+++ b/gcc/ada/sprint.adb
@@ -3780,7 +3780,6 @@ package body Sprint is
       Node_Exists : Boolean := False;
 
    begin
-
       if Is_Non_Empty_List (List) then
 
          if Dump_Original_Only then